<?php
/**
 * @version		$Id: vtiger.php 10 2009-1-22 02:25:51Z ian $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2009 - 2012 openwebapplications.com a division of realetechs, llc. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
require_once (JPATH_COMPONENT.DS.'v_connect.php');
/**
 * User Component Controller
 *
 * @package		Joomla
 * @subpackage	Weblinks
 * @since 1.5
 */
class Vtiger
{
	/**
	 * Method to display a view
	 *
	 * @access	public
	 * @since	1.5
	 */
	private $vdbc;
	private $vtiger_entity_id;
	private $vtiger_db_prfx;
	private $v_result;
	private $joomlavtiger_component_params;
	private $visibility;
		/* start query_list definitions - for the query loop */
	private $v_query_crmentity;
	private $v_query_leads;
	private $v_query_leadaddress;
	private $v_query_leadscf;
	private $v_query_leadsubdetails;
	private $query_chkbx_entity;
	private $query_radio_entity;
	private $query_list;
		/* end of query_list definitions */



	private function _set_vtiger_entity_id() {
		$v_query_update = "UPDATE ".$this->vtiger_db_prfx."_crmentity_seq SET id = LAST_INSERT_ID(id+1)";
		$this->v_result = mysqli_query($this->vdbc,$v_query_update);
		if (!$this->v_result) {
		} else {
			$this->vtiger_entity_id =mysqli_insert_id($this->vdbc);
		}
	}
	private function _joomlavtiger_component_parameters() {
		$this->joomlavtiger_component_params = &JComponentHelper::getParams( 'com_joomlavtiger' );
	}

	private function _get_vtiger_visibility($root_string) {
		$i = 1;
		$v = $this->joomlavtiger_component_params->get($root_string."$i");
		while ($v != '') {
			if (strcasecmp($v,'visible') == 0) {
				$this->visibility[$i-1] = true;
			} else {
				$this->visibility[$i-1] = false;
			}
			$i++;
			$v=$this->joomlavtiger_component_params->get($root_string."$i");
		}
		return $i-1;
	}

	private function _build_query_for_radio_entity($count,$radio_id) {
		$this->query_radio_entity = "INSERT INTO ".$this->vtiger_db_prfx."_senotesrel (crmid,notesid) (SELECT '".$this->vtiger_entity_id."', notesid FROM ".$this->vtiger_db_prfx."_notes WHERE title IN (";
		$value_value = "'xswzvv'))";
		$chb = 'radio_'."$radio_id";
		$k = JRequest::getVar($chb, '', 'post', 'string', JREQUEST_ALLOWRAW);
		for ($i=1; $i <= $count; $i++) {
			if($this->visibility[$i-1]) {
				if ($i == $k) {
					$value_value ="'".$this->joomlavtiger_component_params->get("entity for radio "."$i")."',".$value_value;
				}
			}
		}
		$this->query_radio_entity = $this->query_radio_entity.$value_value;
	}

	private function _build_query_for_checkbox_entity($count) {
		$this->query_chkbx_entity = "INSERT INTO ".$this->vtiger_db_prfx."_seproductsrel (crmid,productid,setype) (SELECT '".$this->vtiger_entity_id."', productid, 'Leads' FROM ".$this->vtiger_db_prfx."_products WHERE productname IN (";
		$value_value = "'xswzvv'))";
		$chb = 'chckbox_';
		for ($i=1; $i <= $count; $i++) {
			if($this->visibility[$i-1]) {
				if (strcasecmp("ON",JRequest::getVar($chb."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)) == 0) {
					$value_value ="'".$this->joomlavtiger_component_params->get("entity for checkbox "."$i")."',".$value_value;
				}
			}
		}
		$this->query_chkbx_entity = $this->query_chkbx_entity.$value_value;
	}

	private function _build_query_for_lead_detail_address($count) {
		$lead_detail = "interest";
		$detail_value ="'Unknown'";
		$lead_address = "leadaddresstype";
		$address_value ="'Billing'";
		for ($i=1; $i <= $count; $i++) {
			if($this->visibility[$i-1]) {
				if (strcasecmp("Company",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_detail = $lead_detail.",company";
					$detail_value =$detail_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Industry",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_detail = $lead_detail.",industry";
					$detail_value =$detail_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Annual Revenue",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_detail = $lead_detail.",annualrevenue";
					$detail_value =$detail_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Phone",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_address = $lead_address.",phone";
					$address_value =$address_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Telehone",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_address = $lead_address.",phone";
					$address_value =$address_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Mobile",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_address = $lead_address.",mobile";
					$address_value =$address_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				} else
				if (strcasecmp("Fax",$this->joomlavtiger_component_params->get("registration form input txt "."$i")) == 0) {
					$lead_address = $lead_address.",fax";
					$address_value =$address_value.",'".JRequest::getVar('input_txt_'."$i", '', 'post', 'string', JREQUEST_ALLOWRAW)."'";
				}
			}
		}
		$email = JRequest::getVar('email', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$firstname = JRequest::getVar('firstname', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$lastname = JRequest::getVar('name', '', 'post', 'string', JREQUEST_ALLOWRAW);
	 	$this->v_query_leads = "INSERT INTO ".$this->vtiger_db_prfx."_leaddetails (leadid, email, firstname, lastname, ".$lead_detail.") VALUES ('".$this->vtiger_entity_id."', '".$email."', '".$firstname."', '".$lastname."',".$detail_value.")";
		$this->v_query_leadaddress = "INSERT INTO ".$this->vtiger_db_prfx."_leadaddress (leadaddressid, ".$lead_address.") VALUES ('".$this->vtiger_entity_id."',".$address_value.")";
	}

	public function init() {
		$this->_joomlavtiger_component_parameters();
		$this->vtiger_db_prfx = $this->joomlavtiger_component_params->get("vtiger_db_prefix");
		$this->_set_vtiger_entity_id();
		if ($this->v_result) {
			$this->visibility = array(false,false,false,false,false,false,false,false,false,false,false,false);
			$count = $this->_get_vtiger_visibility('show hide txt '); /* note the space at the end of the string*/
			$this->_build_query_for_lead_detail_address($count);
			$this->v_query_crmentity = "INSERT INTO ".$this->vtiger_db_prfx."_crmentity (crmid, setype, createdtime, modifiedtime) VALUES ('".$this->vtiger_entity_id."', 'Leads', NOW(), NOW())";
	 		$this->v_query_leadscf = "INSERT INTO ".$this->vtiger_db_prfx."_leadscf (leadid) VALUES ('".$this->vtiger_entity_id."')";
	 		$this->v_query_leadsubdetails = "INSERT INTO ".$this->vtiger_db_prfx."_leadsubdetails (leadsubscriptionid) VALUES ('".$this->vtiger_entity_id."')";
	 		$this->query_chkbx_entity = "";
	 		$this->query_radio_entity = "";
			$this->query_list = array (&$this->v_query_crmentity, &$this->v_query_leads, &$this->v_query_leadaddress, &$this->v_query_leadscf, &$this->v_query_leadsubdetails, &$this->query_chkbx_entity, &$this->query_radio_entity);
		}
		return $this->v_result;
	}
	public function db_connect() {
		$this->vdbc = vtiger_db_connect();
		return $this->vdbc;
	}

	public function db_close() {
		mysqli_close($this->vdbc);
	}

	public function db_insert() {
//ini_set("display_errors", 1);					
		$count = $this->_get_vtiger_visibility('show hide checkbox '); /* note the space at the end of the string*/
		$this->_build_query_for_checkbox_entity($count);
		$count = $this->_get_vtiger_visibility('show hide radio '); /* note the space at the end of the string*/
		$this->_build_query_for_radio_entity($count,1);
//ini_set("display_errors", 0);
//die ($this->v_query_crmentity.$this->v_query_leads.$this->v_query_leadaddress.$this->v_query_leadscf.$this->v_query_leadsubdetails.$this->query_chkbx_entity.$this->query_radio_entity);
		for ($i=0; $i < count($this->query_list); $i++) {
			$this->v_result = mysqli_query($this->vdbc,$this->query_list[$i]);
			if (!$this->v_result) {
				return $this->v_result;
			}
		}
		return $this->v_result;	
	}
}
?>
